diff --git a/sys/dev/raid/arcmsr/arcmsr.c b/sys/dev/raid/arcmsr/arcmsr.c
index 1ee503632f..78b14b15ca 100644
--- a/sys/dev/raid/arcmsr/arcmsr.c
+++ b/sys/dev/raid/arcmsr/arcmsr.c
@@ -4008,123 +4441,170 @@ static u_int32_t arcmsr_initialize(device_t dev)
 	pci_write_config(dev, PCIR_COMMAND, pci_command, 2);
 	switch(acb->adapter_type) {
 	case ACB_ADAPTER_TYPE_A: {
-			u_int32_t rid0 = PCIR_BAR(0);
-			vm_offset_t	mem_base0;
+		u_int32_t rid0 = PCIR_BAR(0);
+		vm_offset_t	mem_base0;
 
-			acb->sys_res_arcmsr[0] = bus_alloc_resource(dev,SYS_RES_MEMORY, &rid0, 0ul, ~0ul, 0x1000, RF_ACTIVE);
-			if(acb->sys_res_arcmsr[0] == NULL) {
+		acb->sys_res_arcmsr[0] = bus_alloc_resource_any(dev,SYS_RES_MEMORY, &rid0, RF_ACTIVE);
+		if(acb->sys_res_arcmsr[0] == NULL) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
+			return ENOMEM;
+		}
+		if(rman_get_start(acb->sys_res_arcmsr[0]) <= 0) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
+			return ENXIO;
+		}
+		mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
+		if(mem_base0 == 0) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
+			return ENXIO;
+		}
+		acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
+		acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
+		acb->pmu = (struct MessageUnit_UNION *)mem_base0;
+		acb->rid[0] = rid0;
+		}
+		break;
+	case ACB_ADAPTER_TYPE_B: {
+		struct HBB_MessageUnit *phbbmu;
+		struct CommandControlBlock *freesrb;
+		u_int32_t rid[]={ PCIR_BAR(0), PCIR_BAR(2) };
+		vm_offset_t	mem_base[]={0,0};
+		u_long	size;
+		if (vendor_dev_id == PCIDevVenIDARC1203)
+			size = sizeof(struct HBB_DOORBELL_1203);
+		else
+			size = sizeof(struct HBB_DOORBELL);
+		for(i=0; i < 2; i++) {
+			acb->sys_res_arcmsr[i] = bus_alloc_resource_any(dev,SYS_RES_MEMORY, &rid[i], RF_ACTIVE);
+			if(acb->sys_res_arcmsr[i] == NULL) {
 				arcmsr_free_resource(acb);
-				kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
+				kprintf("arcmsr%d: bus_alloc_resource %d failure!\n", device_get_unit(dev), i);
 				return ENOMEM;
 			}
-			if(rman_get_start(acb->sys_res_arcmsr[0]) <= 0) {
+			if(rman_get_start(acb->sys_res_arcmsr[i]) <= 0) {
 				arcmsr_free_resource(acb);
-				kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
+				kprintf("arcmsr%d: rman_get_start %d failure!\n", device_get_unit(dev), i);
 				return ENXIO;
 			}
-			mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
-			if(mem_base0 == 0) {
+			mem_base[i] = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[i]);
+			if(mem_base[i] == 0) {
 				arcmsr_free_resource(acb);
-				kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
+				kprintf("arcmsr%d: rman_get_virtual %d failure!\n", device_get_unit(dev), i);
 				return ENXIO;
 			}
-			acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
-			acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
-			acb->pmu = (struct MessageUnit_UNION *)mem_base0;
+			acb->btag[i] = rman_get_bustag(acb->sys_res_arcmsr[i]);
+			acb->bhandle[i] = rman_get_bushandle(acb->sys_res_arcmsr[i]);
+		}
+		freesrb = (struct CommandControlBlock *)acb->uncacheptr;
+		acb->pmu = (struct MessageUnit_UNION *)((unsigned long)freesrb+ARCMSR_SRBS_POOL_SIZE);
+		phbbmu = (struct HBB_MessageUnit *)acb->pmu;
+		phbbmu->hbb_doorbell = (struct HBB_DOORBELL *)mem_base[0];
+		phbbmu->hbb_rwbuffer = (struct HBB_RWBUFFER *)mem_base[1];
+		if (vendor_dev_id == PCIDevVenIDARC1203) {
+			phbbmu->drv2iop_doorbell = offsetof(struct HBB_DOORBELL_1203, drv2iop_doorbell);
+			phbbmu->drv2iop_doorbell_mask = offsetof(struct HBB_DOORBELL_1203, drv2iop_doorbell_mask);
+			phbbmu->iop2drv_doorbell = offsetof(struct HBB_DOORBELL_1203, iop2drv_doorbell);
+			phbbmu->iop2drv_doorbell_mask = offsetof(struct HBB_DOORBELL_1203, iop2drv_doorbell_mask);
+		} else {
+			phbbmu->drv2iop_doorbell = offsetof(struct HBB_DOORBELL, drv2iop_doorbell);
+			phbbmu->drv2iop_doorbell_mask = offsetof(struct HBB_DOORBELL, drv2iop_doorbell_mask);
+			phbbmu->iop2drv_doorbell = offsetof(struct HBB_DOORBELL, iop2drv_doorbell);
+			phbbmu->iop2drv_doorbell_mask = offsetof(struct HBB_DOORBELL, iop2drv_doorbell_mask);
 		}
-		break;
-	case ACB_ADAPTER_TYPE_B: {
-			struct HBB_MessageUnit *phbbmu;
-			struct CommandControlBlock *freesrb;
-			u_int32_t rid[]={ PCIR_BAR(0), PCIR_BAR(2) };
-			vm_offset_t	mem_base[]={0,0};
-			for(i=0; i < 2; i++) {
-				if(i == 0) {
-					acb->sys_res_arcmsr[i] = bus_alloc_resource(dev,SYS_RES_MEMORY, &rid[i],
-											0ul, ~0ul, sizeof(struct HBB_DOORBELL), RF_ACTIVE);
-				} else {
-					acb->sys_res_arcmsr[i] = bus_alloc_resource(dev, SYS_RES_MEMORY, &rid[i],
-											0ul, ~0ul, sizeof(struct HBB_RWBUFFER), RF_ACTIVE);
-				}
-				if(acb->sys_res_arcmsr[i] == NULL) {
-					arcmsr_free_resource(acb);
-					kprintf("arcmsr%d: bus_alloc_resource %d failure!\n", device_get_unit(dev), i);
-					return ENOMEM;
-				}
-				if(rman_get_start(acb->sys_res_arcmsr[i]) <= 0) {
-					arcmsr_free_resource(acb);
-					kprintf("arcmsr%d: rman_get_start %d failure!\n", device_get_unit(dev), i);
-					return ENXIO;
-				}
-				mem_base[i] = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[i]);
-				if(mem_base[i] == 0) {
-					arcmsr_free_resource(acb);
-					kprintf("arcmsr%d: rman_get_virtual %d failure!\n", device_get_unit(dev), i);
-					return ENXIO;
-				}
-				acb->btag[i] = rman_get_bustag(acb->sys_res_arcmsr[i]);
-				acb->bhandle[i] = rman_get_bushandle(acb->sys_res_arcmsr[i]);
-			}
-			freesrb = (struct CommandControlBlock *)acb->uncacheptr;
-			acb->pmu = (struct MessageUnit_UNION *)((unsigned long)freesrb+ARCMSR_SRBS_POOL_SIZE);
-			phbbmu = (struct HBB_MessageUnit *)acb->pmu;
-			phbbmu->hbb_doorbell = (struct HBB_DOORBELL *)mem_base[0];
-			phbbmu->hbb_rwbuffer = (struct HBB_RWBUFFER *)mem_base[1];
+		acb->rid[0] = rid[0];
+		acb->rid[1] = rid[1];
 		}
 		break;
 	case ACB_ADAPTER_TYPE_C: {
-			u_int32_t rid0 = PCIR_BAR(1);
-			vm_offset_t	mem_base0;
+		u_int32_t rid0 = PCIR_BAR(1);
+		vm_offset_t	mem_base0;
 
-			acb->sys_res_arcmsr[0] = bus_alloc_resource(dev,SYS_RES_MEMORY, &rid0, 0ul, ~0ul, sizeof(struct HBC_MessageUnit), RF_ACTIVE);
-			if(acb->sys_res_arcmsr[0] == NULL) {
-				arcmsr_free_resource(acb);
-				kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
-				return ENOMEM;
-			}
-			if(rman_get_start(acb->sys_res_arcmsr[0]) <= 0) {
-				arcmsr_free_resource(acb);
-				kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
-				return ENXIO;
-			}
-			mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
-			if(mem_base0 == 0) {
-				arcmsr_free_resource(acb);
-				kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
-				return ENXIO;
-			}
-			acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
-			acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
-			acb->pmu = (struct MessageUnit_UNION *)mem_base0;
+		acb->sys_res_arcmsr[0] = bus_alloc_resource_any(dev,SYS_RES_MEMORY, &rid0, RF_ACTIVE);
+		if(acb->sys_res_arcmsr[0] == NULL) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
+			return ENOMEM;
+		}
+		if(rman_get_start(acb->sys_res_arcmsr[0]) <= 0) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
+			return ENXIO;
+		}
+		mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
+		if(mem_base0 == 0) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
+			return ENXIO;
+		}
+		acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
+		acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
+		acb->pmu = (struct MessageUnit_UNION *)mem_base0;
+		acb->rid[0] = rid0;
 		}
 		break;
 	case ACB_ADAPTER_TYPE_D: {
-			struct HBD_MessageUnit0 *phbdmu;
-			u_int32_t rid0 = PCIR_BAR(0);
-			vm_offset_t	mem_base0;
-
-			acb->sys_res_arcmsr[0] = bus_alloc_resource(dev,SYS_RES_MEMORY, &rid0, 0ul, ~0ul, sizeof(struct HBD_MessageUnit), RF_ACTIVE);
-			if(acb->sys_res_arcmsr[0] == NULL) {
-				arcmsr_free_resource(acb);
-				kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
-				return ENOMEM;
-			}
-			if(rman_get_start(acb->sys_res_arcmsr[0]) <= 0) {
-				arcmsr_free_resource(acb);
-				kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
-				return ENXIO;
-			}
-			mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
-			if(mem_base0 == 0) {
-				arcmsr_free_resource(acb);
-				kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
-				return ENXIO;
-			}
-			acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
-			acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
-			acb->pmu = (struct MessageUnit_UNION *)((unsigned long)acb->uncacheptr+ARCMSR_SRBS_POOL_SIZE);
-			phbdmu = (struct HBD_MessageUnit0 *)acb->pmu;
-			phbdmu->phbdmu = (struct HBD_MessageUnit *)mem_base0;
+		struct HBD_MessageUnit0 *phbdmu;
+		u_int32_t rid0 = PCIR_BAR(0);
+		vm_offset_t	mem_base0;
+
+		acb->sys_res_arcmsr[0] = bus_alloc_resource_any(dev,SYS_RES_MEMORY, &rid0, RF_ACTIVE);
+		if(acb->sys_res_arcmsr[0] == NULL) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
+			return ENOMEM;
+		}
+		if(rman_get_start(acb->sys_res_arcmsr[0]) <= 0) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
+			return ENXIO;
+		}
+		mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
+		if(mem_base0 == 0) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
+			return ENXIO;
+		}
+		acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
+		acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
+		acb->pmu = (struct MessageUnit_UNION *)((unsigned long)acb->uncacheptr+ARCMSR_SRBS_POOL_SIZE);
+		phbdmu = (struct HBD_MessageUnit0 *)acb->pmu;
+		phbdmu->phbdmu = (struct HBD_MessageUnit *)mem_base0;
+		acb->rid[0] = rid0;
+		}
+		break;
+	case ACB_ADAPTER_TYPE_E: {
+		u_int32_t rid0 = PCIR_BAR(1);
+		vm_offset_t	mem_base0;
+
+		acb->sys_res_arcmsr[0] = bus_alloc_resource(dev,SYS_RES_MEMORY, &rid0, 0ul, ~0ul, sizeof(struct HBE_MessageUnit), RF_ACTIVE);
+		if(acb->sys_res_arcmsr[0] == NULL) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: bus_alloc_resource failure!\n", device_get_unit(dev));
+			return ENOMEM;
+		}
+		if(rman_get_start(acb->sys_res_arcmsr[0]) <= 0) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: rman_get_start failure!\n", device_get_unit(dev));
+			return ENXIO;
+		}
+		mem_base0 = (vm_offset_t) rman_get_virtual(acb->sys_res_arcmsr[0]);
+		if(mem_base0 == 0) {
+			arcmsr_free_resource(acb);
+			kprintf("arcmsr%d: rman_get_virtual failure!\n", device_get_unit(dev));
+			return ENXIO;
+		}
+		acb->btag[0] = rman_get_bustag(acb->sys_res_arcmsr[0]);
+		acb->bhandle[0] = rman_get_bushandle(acb->sys_res_arcmsr[0]);
+		acb->pmu = (struct MessageUnit_UNION *)mem_base0;
+		acb->doneq_index = 0;
+		acb->in_doorbell = 0;
+		acb->out_doorbell = 0;
+		acb->rid[0] = rid0;
+		CHIP_REG_WRITE32(HBE_MessageUnit, 0, host_int_status, 0); /*clear interrupt*/
+		CHIP_REG_WRITE32(HBE_MessageUnit, 0, iobound_doorbell, ARCMSR_HBEMU_DOORBELL_SYNC); /* synchronize doorbell to 0 */
 		}
 		break;
 	}
@@ -4148,6 +4628,40 @@ static u_int32_t arcmsr_initialize(device_t dev)
 	arcmsr_iop_init(acb);
 	return(0);
 }
+
+/*
+************************************************************************
+************************************************************************
+*/
+static void arcmsr_teardown_intr(device_t dev, struct AdapterControlBlock *acb)
+{
+	int i;
+
+	if (acb->acb_flags & ACB_F_MSIX_ENABLED) {
+		for (i = 0; i < acb->msix_vectors; i++) {
+			if (acb->ih[i])
+				bus_teardown_intr(dev, acb->irqres[i], acb->ih[i]);
+		//	if (acb->irqres[i] != NULL)
+		//		bus_release_resource(dev, SYS_RES_IRQ,
+		//		    acb->irq_id[i], acb->irqres[i]);
+
+			acb->ih[i] = NULL;
+		}
+		pci_release_msi(dev);
+	} else {
+		if ((acb->ih[0] != NULL) && (acb->irqres[0] != NULL))
+			bus_teardown_intr(dev, acb->irqres[0], acb->ih[0]);
+		if (acb->irqres[0] != NULL)
+			bus_release_resource(dev, SYS_RES_IRQ,
+			    acb->irq_id[0], acb->irqres[0]);
+		if (acb->irq_type == PCI_INTR_TYPE_MSI)
+      			pci_release_msi(dev);
+		acb->ih[0] = NULL;
+		acb->irqres[0] = NULL;
+		acb->irq_type = 0;
+	}
+
+}
 /*
 ************************************************************************
 ************************************************************************
@@ -4156,10 +4670,9 @@ static int arcmsr_attach(device_t dev)
 {
 	struct AdapterControlBlock *acb=(struct AdapterControlBlock *)device_get_softc(dev);
 	u_int32_t unit=device_get_unit(dev);
-	struct ccb_setasync csa;
+	union ccb *ccb;
 	struct cam_devq	*devq;	/* Device Queue to use for this SIM */
 	struct resource	*irqres;
-	int	rid;
 	u_int irq_flags;
 
 	if(acb == NULL) {
@@ -4171,23 +4684,21 @@ static int arcmsr_attach(device_t dev)
 	acb->pci_unit = unit;
 	if(arcmsr_initialize(dev)) {
 		kprintf("arcmsr%d: initialize failure!\n", unit);
-		arcmsr_mutex_destroy(acb);
-		return ENXIO;
+		goto initialize_failed;
 	}
 	/* After setting up the adapter, map our interrupt */
-	rid=0;
-	acb->irq_type = pci_alloc_1intr(dev, arcmsr_msi_enable, &rid,
-	    &irq_flags);
-	irqres = bus_alloc_resource(dev, SYS_RES_IRQ, &rid, 0ul, ~0ul, 1,
-	    irq_flags);
-	if(irqres == NULL ||
-		bus_setup_intr(dev, irqres, INTR_MPSAFE, arcmsr_intr_handler, acb, &acb->ih, NULL)) {
-		arcmsr_free_resource(acb);
-		arcmsr_mutex_destroy(acb);
-		kprintf("arcmsr%d: unable to register interrupt handler!\n", unit);
-		return ENXIO;
-	}
-	acb->irqres = irqres;
+	acb->irq_id[0] = 0;
+	acb->irq_type = pci_alloc_1intr(dev, arcmsr_msi_enable, &acb->irq_id[0], &irq_flags);
+	irqres = bus_alloc_resource_any(dev, SYS_RES_IRQ, &acb->irq_id[0], irq_flags);
+	if(irqres == NULL ) {
+		kprintf("arcmsr%d: unable to alloc interrupt resource!\n", unit);
+		goto alloc_intr_failed;
+	}
+	if(bus_setup_intr(dev, irqres, INTR_MPSAFE, arcmsr_intr_handler, acb, &acb->ih[0], NULL)) {
+		kprintf("arcmsr%d: unable to setup interrupt handler!\n", unit);
+		goto setup_intr_failed;
+	}
+	acb->irqres[0] = irqres;
 	/*
 	 * Now let the CAM generic SCSI layer find the SCSI devices on
 	 * the bus *  start queue to reset to the idle loop. *
@@ -4196,65 +4707,66 @@ static int arcmsr_attach(device_t dev)
 	*/
 	devq = cam_simq_alloc(acb->maxOutstanding);
 	if(devq == NULL) {
-	    arcmsr_free_resource(acb);
-		bus_release_resource(dev, SYS_RES_IRQ, 0, acb->irqres);
-		if (acb->irq_type == PCI_INTR_TYPE_MSI)
-			pci_release_msi(dev);
-		arcmsr_mutex_destroy(acb);
 		kprintf("arcmsr%d: cam_simq_alloc failure!\n", unit);
-		return ENXIO;
+		goto simq_alloc_failed;
 	}
 	acb->psim = cam_sim_alloc(arcmsr_action, arcmsr_poll, "arcmsr", acb, unit, &acb->isr_lock, 1, ARCMSR_MAX_OUTSTANDING_CMD, devq);
 	cam_simq_release(devq);
 	if(acb->psim == NULL) {
-		arcmsr_free_resource(acb);
-		bus_release_resource(dev, SYS_RES_IRQ, 0, acb->irqres);
-		if (acb->irq_type == PCI_INTR_TYPE_MSI)
-			pci_release_msi(dev);
-		arcmsr_mutex_destroy(acb);
 		kprintf("arcmsr%d: cam_sim_alloc failure!\n", unit);
-		return ENXIO;
+		goto sim_alloc_failed;
 	}
 	ARCMSR_LOCK_ACQUIRE(&acb->isr_lock);
 	if(xpt_bus_register(acb->psim, 0) != CAM_SUCCESS) {
-		arcmsr_free_resource(acb);
-		bus_release_resource(dev, SYS_RES_IRQ, 0, acb->irqres);
-		if (acb->irq_type == PCI_INTR_TYPE_MSI)
-			pci_release_msi(dev);
-		cam_sim_free(acb->psim);
-		arcmsr_mutex_destroy(acb);
 		kprintf("arcmsr%d: xpt_bus_register failure!\n", unit);
-		return ENXIO;
+		goto xpt_bus_failed;
 	}
-	if(xpt_create_path(&acb->ppath, /* periph */ NULL, cam_sim_path(acb->psim), CAM_TARGET_WILDCARD, CAM_LUN_WILDCARD) != CAM_REQ_CMP) {
-		arcmsr_free_resource(acb);
-		bus_release_resource(dev, SYS_RES_IRQ, 0, acb->irqres);
-		if (acb->irq_type == PCI_INTR_TYPE_MSI)
-			pci_release_msi(dev);
-		xpt_bus_deregister(cam_sim_path(acb->psim));
-		cam_sim_free(acb->psim);
-		arcmsr_mutex_destroy(acb);
+	if ((ccb = xpt_alloc_ccb()) == NULL) {
+		kprintf("arcmsr%d: xpt_alloc_ccb failure!\n", unit);
+		goto xpt_ccb_failed;
+	}
+	if(xpt_create_path(&ccb->ccb_h.path, xpt_periph, cam_sim_path(acb->psim), CAM_TARGET_WILDCARD, CAM_LUN_WILDCARD) != CAM_REQ_CMP) {
 		kprintf("arcmsr%d: xpt_create_path failure!\n", unit);
-		return ENXIO;
+		goto xpt_path_failed;
 	}
 	/*
 	****************************************************
 	*/
-	xpt_setup_ccb(&csa.ccb_h, acb->ppath, /*priority*/5);
-	csa.ccb_h.func_code = XPT_SASYNC_CB;
-	csa.event_enable = AC_FOUND_DEVICE|AC_LOST_DEVICE;
-	csa.callback = arcmsr_async;
-	csa.callback_arg = acb->psim;
-	xpt_action((union ccb *)&csa);
+	xpt_setup_ccb(&ccb->ccb_h, ccb->ccb_h.path, /*priority*/5);
+	ccb->ccb_h.func_code = XPT_SCAN_BUS;
+	ccb->ccb_h.cbfcnp = arcmsr_rescanLun_cb;
+	ccb->crcn.flags = CAM_FLAG_NONE;
+	xpt_action(ccb);
 	ARCMSR_LOCK_RELEASE(&acb->isr_lock);
+
 	/* Create the control device.  */
 	acb->ioctl_dev = make_dev(&arcmsr_ops, unit, UID_ROOT, GID_WHEEL /* GID_OPERATOR */, S_IRUSR | S_IWUSR, "arcmsr%d", unit);
-
 	acb->ioctl_dev->si_drv1 = acb;
 	(void)make_dev_alias(acb->ioctl_dev, "arc%d", unit);
 	arcmsr_callout_init(&acb->devmap_callout);
 	callout_reset(&acb->devmap_callout, 60 * hz, arcmsr_polling_devmap, acb);
 	return (0);
+
+xpt_path_failed:
+        xpt_free_ccb(ccb);
+xpt_ccb_failed:
+	xpt_bus_deregister(cam_sim_path(acb->psim));
+xpt_bus_failed:
+	ARCMSR_LOCK_RELEASE(&acb->isr_lock);
+	cam_sim_free(acb->psim);
+sim_alloc_failed:
+	cam_simq_release(devq);
+simq_alloc_failed:
+	arcmsr_teardown_intr(dev, acb);
+setup_intr_failed:
+	arcmsr_free_resource(acb);
+	bus_release_resource(dev, SYS_RES_IRQ, acb->irq_id[0], irqres);
+alloc_intr_failed:
+	if (acb->irq_type == PCI_INTR_TYPE_MSI)
+      		pci_release_msi(dev);
+initialize_failed:
+	arcmsr_mutex_destroy(acb);
+	return ENXIO;
 }
 
 /*
@@ -4306,13 +4818,21 @@ static int arcmsr_probe(device_t dev)
 	case PCIDevVenIDARC1882:
 	case PCIDevVenIDARC1213:
 	case PCIDevVenIDARC1223:
-		if (sub_device_id == ARECA_SUB_DEV_ID_1883)
+		if ((sub_device_id == ARECA_SUB_DEV_ID_1883) ||
+		    (sub_device_id == ARECA_SUB_DEV_ID_1216) ||
+		    (sub_device_id == ARECA_SUB_DEV_ID_1226))
 			type = "SAS 12G";
 		else
 			type = "SAS 6G";
 		arcmsr_msi_enable = 0;
 		break;
+	case PCIDevVenIDARC1884:
+		type = "SAS 12G";
+		arcmsr_msi_enable = 0;
+		break;
 	case PCIDevVenIDARC1214:
+		arcmsr_msi_enable = 0;
+	case PCIDevVenIDARC1203:
 		type = "SATA 6G";
 		break;
 	default:
@@ -4322,8 +4842,8 @@ static int arcmsr_probe(device_t dev)
 	}
 	if(type == x_type)
 		return(ENXIO);
-	ksprintf(buf, "Areca %s Host Adapter RAID Controller%s",
-		type, raid6 ? " (RAID6 capable)" : "");
+	ksprintf(buf, "Areca %s Host Adapter RAID Controller %s\n%s\n",
+		type, raid6 ? "(RAID6 capable)" : "", ARCMSR_DRIVER_VERSION);
 	device_set_desc_copy(dev, buf);
 	return (BUS_PROBE_DEFAULT);
 }
@@ -4378,18 +4898,13 @@ static int arcmsr_detach(device_t dev)
 	int i;
 
 	callout_stop(&acb->devmap_callout);
-	bus_teardown_intr(dev, acb->irqres, acb->ih);
+	arcmsr_teardown_intr(dev, acb);
 	arcmsr_shutdown(dev);
 	arcmsr_free_resource(acb);
-	for(i=0; i<2 && (acb->sys_res_arcmsr[i]!=NULL); i++) {
-		bus_release_resource(dev, SYS_RES_MEMORY, PCIR_BAR(i), acb->sys_res_arcmsr[i]);
+	for(i=0; (i < 2) && (acb->sys_res_arcmsr[i]!=NULL); i++) {
+		bus_release_resource(dev, SYS_RES_MEMORY, acb->rid[i], acb->sys_res_arcmsr[i]);
 	}
-	bus_release_resource(dev, SYS_RES_IRQ, 0, acb->irqres);
-	if (acb->irq_type == PCI_INTR_TYPE_MSI)
-		pci_release_msi(dev);
 	ARCMSR_LOCK_ACQUIRE(&acb->isr_lock);
-	xpt_async(AC_LOST_DEVICE, acb->ppath, NULL);
-	xpt_free_path(acb->ppath);
 	xpt_bus_deregister(cam_sim_path(acb->psim));
 	cam_sim_free(acb->psim);
 	ARCMSR_LOCK_RELEASE(&acb->isr_lock);
